--- old/usr/src/cmd/sendmail/include/sm/mbdb.h	Sat Feb  6 15:36:32 2016
+++ new/usr/src/cmd/sendmail/include/sm/mbdb.h	Sat Feb  6 15:36:32 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001-2002 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: mbdb.h,v 1.6 2002/05/24 20:50:14 gshapiro Exp $
+ *	$Id: mbdb.h,v 1.7 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef SM_MBDB_H
 # define SM_MBDB_H
 
--- old/usr/src/cmd/sendmail/include/sm/misc.h	Sat Feb  6 15:36:32 2016
+++ new/usr/src/cmd/sendmail/include/sm/misc.h	Sat Feb  6 15:36:32 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: misc.h,v 1.1 2006/06/28 23:57:59 ca Exp $
+ *	$Id: misc.h,v 1.2 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef SM_MISC_H
 # define SM_MISC_H 1
 
--- old/usr/src/cmd/sendmail/include/sm/os/sm_os_sunos.h	Sat Feb  6 15:36:32 2016
+++ new/usr/src/cmd/sendmail/include/sm/os/sm_os_sunos.h	Sat Feb  6 15:36:32 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: sm_os_sunos.h,v 1.14 2001/08/14 18:09:42 ca Exp $
+ *	$Id: sm_os_sunos.h,v 1.15 2013-11-22 20:51:34 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  platform definitions for SunOS 4.0.3, SunOS 4.1.x and Solaris 2.x
 */
--- old/usr/src/cmd/sendmail/include/sm/path.h	Sat Feb  6 15:36:32 2016
+++ new/usr/src/cmd/sendmail/include/sm/path.h	Sat Feb  6 15:36:32 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: path.h,v 1.6 2001/04/03 01:53:00 gshapiro Exp $
+ *	$Id: path.h,v 1.7 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  Portable names for standard filesystem paths
 **  and macros for directories.
--- old/usr/src/cmd/sendmail/include/sm/rpool.h	Sat Feb  6 15:36:32 2016
+++ new/usr/src/cmd/sendmail/include/sm/rpool.h	Sat Feb  6 15:36:32 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2003 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2003 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: rpool.h,v 1.16 2003/09/05 23:07:49 ca Exp $
+ *	$Id: rpool.h,v 1.17 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  libsm resource pools
 **  See libsm/rpool.html for documentation.
--- old/usr/src/cmd/sendmail/include/sm/sem.h	Sat Feb  6 15:36:32 2016
+++ new/usr/src/cmd/sendmail/include/sm/sem.h	Sat Feb  6 15:36:32 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2005, 2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2005, 2008 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,7 +6,7 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: sem.h,v 1.10 2008/05/30 16:26:39 ca Exp $
+ *	$Id: sem.h,v 1.11 2013-11-22 20:51:31 ca Exp $
  */
 
 #ifndef SM_SEM_H
--- old/usr/src/cmd/sendmail/include/sm/sendmail.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/sendmail.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -7,8 +7,6 @@
  * the sendmail distribution.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  SENDMAIL.H -- MTA-specific definitions for sendmail.
 */
--- old/usr/src/cmd/sendmail/include/sm/setjmp.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/setjmp.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: setjmp.h,v 1.3 2001/03/08 03:23:08 ca Exp $
+ *	$Id: setjmp.h,v 1.4 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef SM_SETJMP_H
 # define SM_SETJMP_H
 
--- old/usr/src/cmd/sendmail/include/sm/shm.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/shm.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2003, 2005 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2003, 2005 Proofpoint, Inc. and its suppliers.
  *      All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: shm.h,v 1.11 2005/01/13 22:57:04 ca Exp $
+ *	$Id: shm.h,v 1.12 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef SM_SHM_H
 # define SM_SHM_H
 
--- old/usr/src/cmd/sendmail/include/sm/signal.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/signal.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -9,11 +9,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: signal.h,v 1.16 2001/07/20 19:48:21 gshapiro Exp $
+ *	$Id: signal.h,v 1.17 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  SIGNAL.H -- libsm (and sendmail) signal facilities
 **		Extracted from sendmail/conf.h and focusing
--- old/usr/src/cmd/sendmail/include/sm/string.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/string.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001, 2003 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001, 2003 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: string.h,v 1.38 2003/10/10 17:56:57 ca Exp $
+ *	$Id: string.h,v 1.39 2013-11-22 20:51:31 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  libsm string manipulation
 */
--- old/usr/src/cmd/sendmail/include/sm/sysexits.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/sysexits.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1987, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -8,12 +8,10 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: sysexits.h,v 1.5 2001/03/10 17:30:01 ca Exp $
+ *	$Id: sysexits.h,v 1.6 2013-11-22 20:51:31 ca Exp $
  *	@(#)sysexits.h	8.1 (Berkeley) 6/2/93
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef SM_SYSEXITS_H
 # define SM_SYSEXITS_H
 
--- old/usr/src/cmd/sendmail/include/sm/tailq.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/tailq.h	Sat Feb  6 15:36:33 2016
@@ -35,10 +35,8 @@
 #ifndef	SM_TAILQ_H_
 #define	SM_TAILQ_H_
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
- * $Id: tailq.h,v 1.2 2007/06/29 23:09:57 ca Exp $
+ * $Id: tailq.h,v 1.3 2012-01-21 00:12:14 ashish Exp $
  *
  * This file is a modified copy of queue.h from a BSD system:
  * we only need tail queues here.
@@ -71,8 +69,8 @@
 	struct type **tqe_prev;	/* address of previous next element */	\
 }
 
-/* 
- * tail queue access methods 
+/*
+ * tail queue access methods
  */
 #define	SM_TAILQ_FIRST(head)		((head)->tqh_first)
 #define	SM_TAILQ_END(head)		NULL
--- old/usr/src/cmd/sendmail/include/sm/test.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/test.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: test.h,v 1.6 2001/04/03 01:53:01 gshapiro Exp $
+ *	$Id: test.h,v 1.7 2013-11-22 20:51:32 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  Abstractions for writing a libsm test program.
 */
--- old/usr/src/cmd/sendmail/include/sm/time.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/time.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2005 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: time.h,v 1.1 2005/06/14 23:07:19 ca Exp $
+ *	$Id: time.h,v 1.2 2013-11-22 20:51:32 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef SM_TIME_H
 # define SM_TIME_H 1
 
--- old/usr/src/cmd/sendmail/include/sm/types.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/types.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: types.h,v 1.13 2001/04/03 01:53:01 gshapiro Exp $
+ *	$Id: types.h,v 1.14 2013-11-22 20:51:32 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  This header file defines standard integral types.
 **  - It includes <sys/types.h>, and fixes portability problems that
--- old/usr/src/cmd/sendmail/include/sm/varargs.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/varargs.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: varargs.h,v 1.7.2.1 2002/07/29 21:43:20 gshapiro Exp $
+ *	$Id: varargs.h,v 1.9 2013-11-22 20:51:32 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  libsm variable argument lists
 */
--- old/usr/src/cmd/sendmail/include/sm/xtrap.h	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/include/sm/xtrap.h	Sat Feb  6 15:36:33 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: xtrap.h,v 1.7 2001/04/03 01:53:01 gshapiro Exp $
+ *	$Id: xtrap.h,v 1.8 2013-11-22 20:51:32 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  scaffolding for testing exception handler code
 */
--- old/usr/src/cmd/sendmail/libmilter/README	Sat Feb  6 15:36:33 2016
+++ new/usr/src/cmd/sendmail/libmilter/README	Sat Feb  6 15:36:33 2016
@@ -2,8 +2,6 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
-#
 
 The sendmail Mail Filter API (Milter) is designed to allow third-party
 programs access to mail messages as they are being processed in order to
@@ -14,7 +12,8 @@
 file.
 
 Note: if you want to write a milter in Java, then see
-http://sendmail-jilter.sourceforge.net/
+http://sendmail-jilter.sourceforge.net/ or
+http://iws.cs.uni-magdeburg.de/~elkner/milter4j.tgz
 
 +----------------+
 | SECURITY HINTS |
--- old/usr/src/cmd/sendmail/libmilter/comm.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/comm.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2004, 2009 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2004, 2009 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -9,7 +9,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: comm.c,v 8.70 2009/12/16 16:33:48 ca Exp $")
+SM_RCSID("@(#)$Id: comm.c,v 8.71 2013-11-22 20:51:36 ca Exp $")
 
 #include "libmilter.h"
 #include <sm/errstring.h>
--- old/usr/src/cmd/sendmail/libmilter/engine.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/engine.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2004, 2006-2008 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2004, 2006-2008 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -9,7 +9,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: engine.c,v 8.166 2009/11/06 00:57:07 ca Exp $")
+SM_RCSID("@(#)$Id: engine.c,v 8.168 2013-11-22 20:51:36 ca Exp $")
 
 #include "libmilter.h"
 
@@ -284,7 +284,7 @@
 		if (mi_stop() == MILTER_ABRT)
 		{
 			if (ctx->ctx_dbg > 3)
-				sm_dprintf("[%ld] milter_abort\n",
+				sm_dprintf("[%lu] milter_abort\n",
 					(long) ctx->ctx_id);
 			ret = MI_FAILURE;
 			break;
@@ -315,7 +315,7 @@
 		    cmd < SMFIC_VALIDCMD)
 		{
 			if (ctx->ctx_dbg > 5)
-				sm_dprintf("[%ld] mi_engine: mi_rd_cmd error (%x)\n",
+				sm_dprintf("[%lu] mi_engine: mi_rd_cmd error (%x)\n",
 					(long) ctx->ctx_id, (int) cmd);
 
 			/*
@@ -328,7 +328,7 @@
 			break;
 		}
 		if (ctx->ctx_dbg > 4)
-			sm_dprintf("[%ld] got cmd '%c' len %d\n",
+			sm_dprintf("[%lu] got cmd '%c' len %d\n",
 				(long) ctx->ctx_id, cmd, (int) len);
 		for (i = 0; i < ncmds; i++)
 		{
@@ -339,7 +339,7 @@
 		{
 			/* unknown command */
 			if (ctx->ctx_dbg > 1)
-				sm_dprintf("[%ld] cmd '%c' unknown\n",
+				sm_dprintf("[%lu] cmd '%c' unknown\n",
 					(long) ctx->ctx_id, cmd);
 			ret = MI_FAILURE;
 			break;
@@ -348,7 +348,7 @@
 		{
 			/* stop for now */
 			if (ctx->ctx_dbg > 1)
-				sm_dprintf("[%ld] cmd '%c' not impl\n",
+				sm_dprintf("[%lu] cmd '%c' not impl\n",
 					(long) ctx->ctx_id, cmd);
 			ret = MI_FAILURE;
 			break;
@@ -357,7 +357,7 @@
 		/* is new state ok? */
 		newstate = cmds[i].cm_next;
 		if (ctx->ctx_dbg > 5)
-			sm_dprintf("[%ld] cur %x new %x nextmask %x\n",
+			sm_dprintf("[%lu] cur %x new %x nextmask %x\n",
 				(long) ctx->ctx_id,
 				curstate, newstate, next_states[curstate]);
 
@@ -364,7 +364,7 @@
 		if (newstate != ST_NONE && !trans_ok(curstate, newstate))
 		{
 			if (ctx->ctx_dbg > 1)
-				sm_dprintf("[%ld] abort: cur %d (%x) new %d (%x) next %x\n",
+				sm_dprintf("[%lu] abort: cur %d (%x) new %d (%x) next %x\n",
 					(long) ctx->ctx_id,
 					curstate, MI_MASK(curstate),
 					newstate, MI_MASK(newstate),
@@ -434,7 +434,7 @@
 		else if (r == _SMFIS_ABORT)
 		{
 			if (ctx->ctx_dbg > 5)
-				sm_dprintf("[%ld] function returned abort\n",
+				sm_dprintf("[%lu] function returned abort\n",
 					(long) ctx->ctx_id);
 			ret = MI_FAILURE;
 			break;
@@ -1122,7 +1122,7 @@
 	fix_stm(ctx);
 
 	if (ctx->ctx_dbg > 3)
-		sm_dprintf("[%ld] milter_negotiate:"
+		sm_dprintf("[%lu] milter_negotiate:"
 			" mta_actions=0x%lx, mta_flags=0x%lx"
 			" actions=0x%lx, flags=0x%lx\n"
 			, (long) ctx->ctx_id
@@ -1131,7 +1131,7 @@
 
 #if _FFR_MILTER_CHECK
 	if (ctx->ctx_dbg > 3)
-		sm_dprintf("[%ld] milter_negotiate:"
+		sm_dprintf("[%lu] milter_negotiate:"
 			" testmode=%d, pflags2mta=%X, internal_pflags=%X\n"
 			, (long) ctx->ctx_id, testmode
 			, ctx->ctx_pflags2mta, internal_pflags);
--- old/usr/src/cmd/sendmail/libmilter/example.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/example.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,7 +6,7 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- * $Id: example.c,v 8.4 2008/07/22 15:12:47 ca Exp $
+ * $Id: example.c,v 8.5 2013-11-22 20:51:36 ca Exp $
  */
 
 /*
--- old/usr/src/cmd/sendmail/libmilter/handler.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/handler.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2003, 2006 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2003, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -9,7 +9,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: handler.c,v 8.39 2008/11/25 01:14:16 ca Exp $")
+SM_RCSID("@(#)$Id: handler.c,v 8.40 2013-11-22 20:51:36 ca Exp $")
 
 #include "libmilter.h"
 
--- old/usr/src/cmd/sendmail/libmilter/libmilter.h	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/libmilter.h	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2003, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2003, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -19,7 +19,7 @@
 #ifdef _DEFINE
 # define EXTERN
 # define INIT(x)	= x
-SM_IDSTR(MilterlId, "@(#)$Id: libmilter.h,v 8.77 2008/11/25 18:28:18 ca Exp $")
+SM_IDSTR(MilterlId, "@(#)$Id: libmilter.h,v 8.78 2013-11-22 20:51:36 ca Exp $")
 #else /* _DEFINE */
 # define EXTERN extern
 # define INIT(x)
--- old/usr/src/cmd/sendmail/libmilter/listener.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/listener.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2007 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2007 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -9,7 +9,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: listener.c,v 8.126 2009/12/16 16:40:23 ca Exp $")
+SM_RCSID("@(#)$Id: listener.c,v 8.127 2013-11-22 20:51:36 ca Exp $")
 
 /*
 **  listener.c -- threaded network listener
--- old/usr/src/cmd/sendmail/libmilter/main.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/main.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2003, 2006, 2007 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2003, 2006, 2007 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -9,7 +9,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: main.c,v 8.84 2008/09/02 05:37:06 ca Exp $")
+SM_RCSID("@(#)$Id: main.c,v 8.85 2013-11-22 20:51:36 ca Exp $")
 
 #define _DEFINE	1
 #include "libmilter.h"
--- old/usr/src/cmd/sendmail/libmilter/monitor.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/monitor.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: monitor.c,v 8.7 2007/04/23 16:26:28 ca Exp $")
+SM_RCSID("@(#)$Id: monitor.c,v 8.8 2013-11-22 20:51:36 ca Exp $")
 #include "libmilter.h"
 
 #if _FFR_THREAD_MONITOR
--- old/usr/src/cmd/sendmail/libmilter/signal.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/signal.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2004, 2006 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2004, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: signal.c,v 8.44 2006/03/03 03:42:04 ca Exp $")
+SM_RCSID("@(#)$Id: signal.c,v 8.45 2013-11-22 20:51:36 ca Exp $")
 
 #include "libmilter.h"
 
--- old/usr/src/cmd/sendmail/libmilter/sm_gethost.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/sm_gethost.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2001, 2004 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2001, 2004, 2010, 2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: sm_gethost.c,v 8.27 2004/08/20 21:12:37 ca Exp $")
+SM_RCSID("@(#)$Id: sm_gethost.c,v 8.32 2013-11-22 20:51:36 ca Exp $")
 
 #include <sendmail.h>
 #if NETINET || NETINET6
@@ -32,7 +30,7 @@
 
 #if NETINET6 && NEEDSGETIPNODE
 
-static struct hostent *getipnodebyname __P((char *, int, int, int *));
+static struct hostent *sm_getipnodebyname __P((const char *, int, int, int *));
 
 # ifndef AI_ADDRCONFIG
 #  define AI_ADDRCONFIG	0	/* dummy */
@@ -45,8 +43,8 @@
 # endif /* ! AI_DEFAULT */
 
 static struct hostent *
-getipnodebyname(name, family, flags, err)
-	char *name;
+sm_getipnodebyname(name, family, flags, err)
+	const char *name;
 	int family;
 	int flags;
 	int *err;
@@ -64,7 +62,18 @@
 	h = gethostbyname(name);
 	if (family == AF_INET6 && !resv6)
 		_res.options &= ~RES_USE_INET6;
-	*err = h_errno;
+
+	/* the function is supposed to return only the requested family */
+	if (h != NULL && h->h_addrtype != family)
+	{
+# if NETINET6
+		freehostent(h);
+# endif /* NETINET6 */
+		h = NULL;
+		*err = NO_DATA;
+	}
+	else
+		*err = h_errno;
 	return h;
 }
 
@@ -79,6 +88,8 @@
 
 	return;
 }
+#else /* NEEDSGETIPNODE && NETINET6 */
+#define sm_getipnodebyname getipnodebyname 
 #endif /* NEEDSGETIPNODE && NETINET6 */
 
 struct hostent *
@@ -101,7 +112,12 @@
 # endif /* SOLARIS == 20300 || SOLARIS == 203 */
 #else /* (SOLARIS > 10000 && SOLARIS < 20400) || (defined(SOLARIS) && SOLARIS < 204) || (defined(sony_news) && defined(__svr4)) */
 # if NETINET6
-	int flags = AI_DEFAULT|AI_ALL;
+#  ifndef SM_IPNODEBYNAME_FLAGS
+    /* For IPv4-mapped addresses, use: AI_DEFAULT|AI_ALL */
+#   define SM_IPNODEBYNAME_FLAGS	AI_ADDRCONFIG
+#  endif /* SM_IPNODEBYNAME_FLAGS */
+
+	int flags = SM_IPNODEBYNAME_FLAGS;
 	int err;
 # endif /* NETINET6 */
 
@@ -109,7 +125,7 @@
 #  if ADDRCONFIG_IS_BROKEN
 	flags &= ~AI_ADDRCONFIG;
 #  endif /* ADDRCONFIG_IS_BROKEN */
-	h = getipnodebyname(name, family, flags, &err);
+	h = sm_getipnodebyname(name, family, flags, &err);
 	SM_SET_H_ERRNO(err);
 # else /* NETINET6 */
 	h = gethostbyname(name);
@@ -116,6 +132,16 @@
 # endif /* NETINET6 */
 
 #endif /* (SOLARIS > 10000 && SOLARIS < 20400) || (defined(SOLARIS) && SOLARIS < 204) || (defined(sony_news) && defined(__svr4)) */
+
+	/* the function is supposed to return only the requested family */
+	if (h != NULL && h->h_addrtype != family)
+	{
+# if NETINET6
+		freehostent(h);
+# endif /* NETINET6 */
+		h = NULL;
+		SM_SET_H_ERRNO(NO_DATA);
+	}
 	return h;
 }
 
--- old/usr/src/cmd/sendmail/libmilter/smfi.c	Sat Feb  6 15:36:34 2016
+++ new/usr/src/cmd/sendmail/libmilter/smfi.c	Sat Feb  6 15:36:34 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 1999-2007 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 1999-2007 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: smfi.c,v 8.83 2007/04/23 16:44:39 ca Exp $")
+SM_RCSID("@(#)$Id: smfi.c,v 8.84 2013-11-22 20:51:36 ca Exp $")
 #include <sm/varargs.h>
 #include "libmilter.h"
 
--- old/usr/src/cmd/sendmail/libmilter/worker.c	Sat Feb  6 15:36:35 2016
+++ new/usr/src/cmd/sendmail/libmilter/worker.c	Sat Feb  6 15:36:35 2016
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 2003-2004, 2007, 2009 Sendmail, Inc. and its suppliers.
+ *  Copyright (c) 2003-2004, 2007, 2009-2012 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -11,7 +11,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: worker.c,v 8.17 2009/06/15 15:34:54 ca Exp $")
+SM_RCSID("@(#)$Id: worker.c,v 8.25 2013-11-22 20:51:37 ca Exp $")
 
 #include "libmilter.h"
 
@@ -141,7 +141,8 @@
 
 #if POOL_DEBUG
 # define POOL_LEV_DPRINTF(lev, x)					\
-	do {								\
+	do								\
+	{								\
 		if ((lev) < ctx->ctx_dbg)				\
 			sm_dprintf x;					\
 	} while (0)
@@ -165,7 +166,9 @@
 {
 	static long id = 0;
 
-	SM_ASSERT(Tskmgr.tm_signature == TM_SIGNATURE);
+	/* this can happen if the milter is shutting down */
+	if (Tskmgr.tm_signature != TM_SIGNATURE)
+		return MI_FAILURE;
 	SM_ASSERT(ctx != NULL);
 	POOL_LEV_DPRINTF(4, ("PIPE r=[%d] w=[%d]", RD_PIPE, WR_PIPE));
 	TASKMGR_LOCK();
@@ -216,6 +219,41 @@
 }
 
 /*
+**  NONBLOCKING -- set nonblocking mode for a file descriptor.
+**
+**	Parameters:
+**		fd -- file descriptor
+**		name -- name for (error) logging
+**
+**	Returns:
+**		MI_SUCCESS/MI_FAILURE
+*/
+
+static int
+nonblocking(int fd, const char *name)
+{
+	int r;
+
+	errno = 0;
+	r = fcntl(fd, F_GETFL, 0);
+	if (r == -1)
+	{
+		smi_log(SMI_LOG_ERR, "fcntl(%s, F_GETFL)=%s",
+			name, sm_errstring(errno));
+		return MI_FAILURE;
+	}
+	errno = 0;
+	r = fcntl(fd, F_SETFL, r | O_NONBLOCK);
+	if (r == -1)
+	{
+		smi_log(SMI_LOG_ERR, "fcntl(%s, F_SETFL, O_NONBLOCK)=%s",
+			name, sm_errstring(errno));
+		return MI_FAILURE;
+	}
+	return MI_SUCCESS;
+}
+
+/*
 **  MI_POOL_CONTROLER_INIT -- Launch the worker pool controller
 **		Must be called before starting sessions.
 **
@@ -246,6 +284,12 @@
 			sm_errstring(errno));
 		return MI_FAILURE;
 	}
+	r = nonblocking(WR_PIPE, "WR_PIPE");
+	if (r != MI_SUCCESS)
+		return r;
+	r = nonblocking(RD_PIPE, "RD_PIPE");
+	if (r != MI_SUCCESS)
+		return r;
 
 	(void) smutex_init(&Tskmgr.tm_w_mutex);
 	(void) scond_init(&Tskmgr.tm_w_cond);
@@ -334,7 +378,7 @@
 	for (;;)
 	{
 		SMFICTX_PTR ctx;
-		int nfd, rfd, i;
+		int nfd, r, i;
 		time_t now;
 
 		POOL_LEV_DPRINTF(4, ("Let's %s again...", WAITFN));
@@ -455,19 +499,19 @@
 		TASKMGR_UNLOCK();
 
 		/* Everything is ready, let's wait for an event */
-		rfd = poll(pfd, nfd, POLL_TIMEOUT);
+		r = poll(pfd, nfd, POLL_TIMEOUT);
 
 		POOL_LEV_DPRINTF(4, ("%s returned: at epoch %d value %d",
 			WAITFN, now, nfd));
 
 		/* timeout */
-		if (rfd == 0)
+		if (r == 0)
 			continue;
 
 		rebuild_set = true;
 
 		/* error */
-		if (rfd < 0)
+		if (r < 0)
 		{
 			if (errno == EINTR)
 				continue;
@@ -479,6 +523,7 @@
 
 			if (pcnt >= MAX_FAILS_S)
 				goto err;
+			continue;
 		}
 		pcnt = 0;
 
@@ -492,28 +537,26 @@
 				WAITFN, i, nfd,
 			WAIT_FD(i)));
 
-			/* has a worker signaled an end of task ? */
+			/* has a worker signaled an end of task? */
 			if (WAIT_FD(i) == RD_PIPE)
 			{
-				char evt = 0;
-				int r = 0;
+				char evts[256];
+				ssize_t r;
 
 				POOL_LEV_DPRINTF(4,
 					("PIPE WILL READ evt = %08X %08X",
 					pfd[i].events, pfd[i].revents));
 
-				if ((pfd[i].revents & MI_POLL_RD_FLAGS) != 0)
+				r = 1;
+				while ((pfd[i].revents & MI_POLL_RD_FLAGS) != 0
+					&& r != -1)
 				{
-					r = read(RD_PIPE, &evt, sizeof(evt));
-					if (r == sizeof(evt))
-					{
-						/* Do nothing */
-					}
+					r = read(RD_PIPE, evts, sizeof(evts));
 				}
 
 				POOL_LEV_DPRINTF(4,
 					("PIPE DONE READ i=[%d] fd=[%d] r=[%d] evt=[%d]",
-					i, RD_PIPE, r, evt));
+					i, RD_PIPE, (int) r, evts[0]));
 
 				if ((pfd[i].revents & ~MI_POLL_RD_FLAGS) != 0)
 				{
@@ -522,7 +565,12 @@
 				continue;
 			}
 
-			/* no ! sendmail wants to send a command */
+			/*
+			**  Not the pipe for workers waking us,
+			**  so must be something on an MTA connection.
+			*/
+
+			TASKMGR_LOCK();
 			SM_TAILQ_FOREACH(ctx, &WRK_CTX_HEAD, ctx_link)
 			{
 				if (ctx->ctx_wstate != WKST_WAITING)
@@ -534,7 +582,6 @@
 
 				if (ctx->ctx_sd == pfd[i].fd)
 				{
-					TASKMGR_LOCK();
 
 					POOL_LEV_DPRINTF(4,
 						("TASK: found %d for fd[%d]=%d",
@@ -550,10 +597,10 @@
 						ctx->ctx_wstate = WKST_RUNNING;
 						LAUNCH_WORKER(ctx);
 					}
-					TASKMGR_UNLOCK();
 					break;
 				}
 			}
+			TASKMGR_UNLOCK();
 
 			POOL_LEV_DPRINTF(4,
 				("TASK %s FOUND - Checking PIPE for fd[%d]",
@@ -566,6 +613,14 @@
 		free(pfd);
 
 	Tskmgr.tm_signature = 0;
+#if 0
+	/*
+	**  Do not clean up ctx -- it can cause double-free()s.
+	**  The program is shutting down anyway, so it's not worth the trouble.
+	**  There is a more complex solution that prevents race conditions
+	**  while accessing ctx, but that's maybe for a later version.
+	*/
+
 	for (;;)
 	{
 		SMFICTX_PTR ctx;
@@ -575,6 +630,7 @@
 			break;
 		mi_close_session(ctx);
 	}
+#endif
 
 	(void) smutex_destroy(&Tskmgr.tm_w_mutex);
 	(void) scond_destroy(&Tskmgr.tm_w_cond);
--- old/usr/src/cmd/sendmail/libsm/assert.c	Sat Feb  6 15:36:35 2016
+++ new/usr/src/cmd/sendmail/libsm/assert.c	Sat Feb  6 15:36:35 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,10 +8,8 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: assert.c,v 1.25.2.1 2003/12/05 22:44:17 ca Exp $")
+SM_RCSID("@(#)$Id: assert.c,v 1.27 2013-11-22 20:51:42 ca Exp $")
 
 /*
 **  Abnormal program termination and assertion checking.
